{
***************************************************************************
*                                                     *                   *
*       AV_asm_vid_x.spin                             *   A. Vreugdenhil  *
*                                                     *                   *
*       Use a Composite Video Camera as a lijnsensor  *   Westland @2016  *
*                                                     *       B+ club     *
*       Prop_Video                                    *     HvB DJ AvdL   *
*                                                     *      WJ JV AV     *
*                                                     *                   *
*       Spring 2016, start with the Project           *********************
*       Goal is to play on the Roborama game at Oktober 2016              *
*                                                                         *
*       Thanks to my Big hero: Jon "JonnyMac" McPhalen                    *
*                                                                         *
*       v5 is goedwerkend met 1 lijn detecteren !!!!!!!!!!!!!!!!!!        *
*       v5b is poging om de 1 pixel "fout" eruit te halen                 *
*                                                                         *
***************************************************************************
}

CON                                    'Constant declaration header
  _clkmode = xtal1 + pll16x            '16X multiplier for the crystal frequency
  _xinfreq = 5_000_000                 'frequency of the crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq               ' system freq as a constant
  MS_001   = CLK_FREQ / 1_000                                   ' ticks in 1ms
  US_001   = CLK_FREQ / 1_000_000                               ' ticks in 1us

  LEDS          = 0                                             ' WS2812-LED tx pin
  STRIP_LEN     = 16                                            ' Aantal NeoPixel's op rij 
  ServoL        = 11                                            ' Set servo on pin11  ; could be any pin 
  ServoR        = 12                                            ' Set servo on pin12  ; could be any pin
  Pot_Down      = 22                                            ' Digitale potmeter        
  Pot_Up        = 23                                            ' Digitale potmeter 
  menu_max      = 3                                             ' Nu Maximaal 3 menu items
  

VAR

  long Stack
  byte rood
  byte groen
  byte blauw
  long kleur
  long temp_stack
  long stack_
  long temp3
  byte temp
  byte temp5
  byte temp6
  byte temp4
  byte  Lijn_lengte
  byte  Lijn_midden
  byte menu
  byte menu_oud
  byte toets
  byte toets_oud
  long tijd_begin
  long tijd_eind
  long tijd
  byte uitvoer
  long offset 


OBJ
'*** Used object's ****************************************************

  fdx   : "FullDuplexSerial_rr004"
  strip : "jm_ws2812"                                           ' WS2812 LED driver
  SERVO : "Servo32"    


PUB main                               

  dira[Pot_Down] := 1
  outa[Pot_Down] := 1                                   ' Laag = actief
  dira[Pot_UP] := 1
  outa[Pot_UP] := 1                                     ' Laag = actief    
  
  strip.start_b(LEDS, STRIP_LEN)                        ' Start led driver
  strip.off
  
  SERVO.Set(ServoL,1500)
  SERVO.Set(ServoR,1500)

  SERVO.Start                                           ' Start Servo handler

  menu := 1
  menu_oud := 1
  toets := ina[4]
  toets_oud := toets
  uitvoer := 0
  
' *********************************************************************     
  fdx.start(31,30, %0000, 115_200)                      ' Start seriele communicatie op                                  
' *********************************************************************     

  cognew(@video, @Stack)                                ' Start de "Video Opname" Cog
  pause(1000)                                           ' Wacht tot Cog gestart is
                                          
  repeat 1
    color_chase(@Chakras, STRIP_LEN, 100)               ' Show, het oog wil ook wat.

  pause(1000)                                           ' Wacht 1 seconde
  fdx.str(string("Video Lijnvolger    @2016",13,10))
  fdx.str(string("Powered by Propeller chip",13,10))  
  fdx.str(string("B+ Westland <---> AV_Tech",13,10))
  fdx.str(string("Programma Versie 5b",13,13,10))

  strip.off
  strip.setx(menu + 8, $FF_FF_FF , 32)
  
  repeat
    toets := ina[4]
    if toets <> toets_oud
      toets_afhandeling
    if uitvoer == 1
      case menu
        1 :Lijn_volgen
        2 :Ijk_camera
        3 :licht_show
      uitvoer := 0


PUB Lijn_volgen

  fdx.str(string("Lijnvolgen ",13,10)) 

  repeat while (ina[4] == 1)
    waitcnt(8_000_000 + cnt)                            ' 1/10 seconde
    Lijn_kleur                                          ' Zet lijn op WS2812-display
    Lijn_positie                                        ' Bereken Lijn_lengte, Lijn_midden
    Motoren                                             ' Geef de servo motoren een waarde 

  SERVO.Set(ServoR,1500)    
  SERVO.Set(ServoL,1500)

  strip.off
  strip.setx(menu + 8, $FF_FF_FF , 32)
  waitcnt(20_000_000 + cnt)


PUB licht_show

  fdx.str(string("Lichtshow",13,10))
  
  repeat 5
    color_chase(@Chakras, STRIP_LEN, 100)               ' Show, het oog wil ook wat.

  waitcnt(40_000_000 + cnt)
  strip.off
  strip.setx(menu + 8, $FF_FF_FF , 32)


PUB toets_afhandeling
  pause(25)                                             ' Contact denker
  if toets == 1                                         ' Toets met pull-up weerstand
    tijd_eind := cnt     
    tijd := tijd_eind - tijd_begin
    if tijd < 40_000_000
      menu := menu + 1
      if menu > menu_max
        menu := 1
        strip.setx(menu + 8, $FF_FF_FF , 32)
        strip.setx(menu_max + 8, $00_00_00 , 32)
      strip.setx(menu + 8, $FF_FF_FF , 32)
      strip.setx(menu + 7, $00_00_00 , 32)
    else
      uitvoer := 1
        
    fdx.dec(tijd)                                    ' Later eruit ivm snelheid
    fdx.str(string(13))
    toets_oud := toets    
  else
    tijd_begin := cnt
    toets_oud := toets  


PUB Motoren
  if Lijn_lengte <> 1
    SERVO.Set(ServoR,(1200 + (Lijn_midden * 35)))           '1400 + * 25
    SERVO.Set(ServoL,(1800 - ((32 - Lijn_midden) * 35)))    '1600 - * 25
  else
    SERVO.Set(ServoR,1500)    
    SERVO.Set(ServoL,1500)      


PUB Lijn_positie 
' *********************************************************************
' *** 
' *********************************************************************        
  stack_ := Stack
  temp3 := 0  
  offset := 0

  repeat
    Lijn_puls
    if lijn_lengte > 1
      quit
    if lijn_midden == 31
      quit


PUB Lijn_puls

  repeat 
    temp3 := |< offset  
    temp_stack := stack_ & temp3
    if temp_stack <> 0
      quit
    if offset == 31
      quit
    offset := offset + 1

  temp5 := offset
'  offset := offset + 1             ' ???
  
  repeat
    temp3 := |< offset  
    temp_stack := stack_ & temp3
    if temp_stack == 0
      quit
    if offset == 31
      quit
    offset := offset + 1
  
  temp6 := offset

  Lijn_lengte := temp6 - temp5
  Lijn_midden := temp6 +  temp5
  Lijn_midden := Lijn_midden / 2

   
PUB Lijn_kleur
' *********************************************************************
' *** Zet de lijn in het rood op een groene ondergrond.
' ********************************************************************* 
  stack_ := Stack
  temp3 := 0

  fdx.bin(stack_,32)                                    ' Later eruit ivm snelheid
  fdx.str(string(13))                                   ' Later eruit ivm snelheid
  
  repeat 8
    temp_stack := stack_ & %00000000_00000000_00000000_00001111
    rood := temp_stack << 2
    groen := %00111100 - rood
    blauw := 0
    kleur := ((rood << 16) + (groen << 8) + blauw)
    strip.setx(temp3, kleur , 128)
    temp3 := temp3 + 1
    stack_ := stack_ >> 4


PUB Ijk_camera | vinkje

  fdx.str(string("Camera ijking",13,10))
  strip.setx(1, $FF_FF_FF , 32)
  
  repeat 32
    Potmeter_down
' *********************************************************************
' *** Wacht op begin lijn
' *********************************************************************
  repeat
    temp_stack := Stack & %000000_00011111_11111000_000000
    if temp_stack <> 0
      quit
    temp := temp + 1
    if temp == 32
      quit
    Potmeter_up
    
  temp5 := temp
    
' *********************************************************************
' *** Wacht op einde lijn
' *********************************************************************
  repeat
    temp_stack := Stack & %01111111_11100000_00000111_11111110
    if temp_stack <> 0
      quit
    if temp5 == 32
      quit
    temp5 := temp5 + 1
    Potmeter_up

' *********************************************************************
' *** Neem het gemiddelde
' *********************************************************************
  temp5 := temp5 + temp
  temp5 := temp5 / 2

  repeat 32
    Potmeter_down

' *********************************************************************
' *** Stel hier de Potmeter op in
' *********************************************************************
  repeat temp5
    Potmeter_up  

  fdx.dec(temp5)                                    ' Later eruit ivm snelheid
  fdx.str(string(13))  
  fdx.str(string("Einde ijking",13,10))
  strip.setx(1, $00_00_00 , 32)    
 
  
PUB Potmeter_up
  
  outa[Pot_Up] := 0  
  pause(50)
  outa[Pot_Up] := 1
  pause(50)          


PUB Potmeter_down

  outa[Pot_Down] := 0  
  pause(50)
  outa[Pot_Down] := 1
  pause(50)                  


pub color_chase(p_colors, len, ms) | base, idx, ch

'' Performs color chase 

  repeat base from 0 to len-1                                   ' do all colors in table
    idx := base                                                 ' start at base
    repeat ch from 0 to strip.num_pixels-1                      ' loop through connected leds
      strip.setx(ch, long[p_colors][idx],32)                    ' update channel color 
'      strip.set(ch, long[p_colors][idx])                       ' Orgineel van jm
      if (++idx == len)                                         ' past end of list?
        idx := 0                                                ' yes, reset
   
    pause(ms)                                                   ' set movement speed


pub pause(ms) | t

'' Delay program in milliseconds

  if (ms < 1)                                                   ' delay must be > 0
    return
  else
    t := cnt - 1776                                             ' sync with system counter
    repeat ms                                                   ' run delay
      waitcnt(t += MS_001)


DAT

  Chakras               long    strip#RED, strip#ORANGE, strip#YELLOW 
                        long    strip#GREEN, strip#BLUE, strip#INDIGO
                         

DAT                           
           org          0                       ' Begin vh programma staat op adres 0 in cog
video      mov          dira,   led             ' Maak LED uitgang
           xor          outa,   led             ' Zet LED AAN (= toggle)
' **************************************************************************************
' *** Wacht op V-Sync (Field-Sync)
' **************************************************************************************                                       
begin      mov          temp1,  ina             ' \
           andn         temp1,  mask_V wz       '  Wacht op neergaande flank
           if_nz        jmp     #begin          ' /
' **************************************************************************************
' *** Wacht op H-Sync, 25 keer. (Line-Sync)
' **************************************************************************************  
           mov          lus,    lijn_250         ' laad lus met 250

begin1     mov          temp1,  ina             ' \
           andn         temp1,  mask_H wz       '  Wacht op neergaande flank
           if_nz        jmp     #begin1         ' /
                      
stap_2     mov          temp1,  ina
           andn         temp1,  mask_H wz    
           if_z         jmp     #stap_2         ' Hierna is de flank weer hoog

           djnz         lus,    #begin1         ' Trek van lus 1 af geen 0 dan spring terug
' **************************************************************************************
' *** Knipper LED en wacht een paar microseconde
' **************************************************************************************  
           xor          outa,   led             ' Toggle/Knipper LED
'           mov          terug,  #3              ' we gaan 3 keer een lijn meten

beeld_3    mov          temp2,  #pauze          ' we gaan de 155 clk tussen de pixels tellen
loop_1     djnz         temp2,  #loop_1         ' djnz = 4 clk * 38 = 152
' **************************************************************************************
' *** Gaan 32 metingen doen
' **************************************************************************************  
           mov          lus,    #wacht          ' we zetten 32 in lus
           mov          meet,   #0              ' maak meet leeg ??
           
beeld      shl          meet,   #1              ' schuif meet naar links
           mov          temp1,  ina             ' kijk op ingang_lijn
           andn         temp1,  mask_L wz       ' is deze 1
           if_z         jmp     #beeld_2        ' NEE spring verder weg
           add          meet,   #1              ' Tel er 1 bij op

beeld_2    mov          temp2,  #24             ' we gaan de 155 clk tussen de pixels telle
loop       djnz         temp2,  #loop           ' djnz = 4 clk * 38 = 152
         
           djnz         lus,    #beeld          ' zijn er 32 metingen gedaan ?
           
'           shl          meet,   #1
           wrlong       meet,   par             ' Schrijf gegevens naar par-register
' **************************************************************************************
' *** Spring weer naar boven
' **************************************************************************************          
           jmp          #begin

'======================================================================
{Hier staan de declaraties van de variable}  '
            '
led        long       |<1                       ' Pin is set to 1
mask_V     long       %11111111_11111110_11111111_11111111
mask_H     long       %11111111_11111101_11111111_11111111
mask_L     long       %11111101_11111111_11111111_11111111
pauze      long       2800   
lijn_250   long       250
lijn_135   long       135
wacht      long       32
aantal     long       2

meet       res        1
temp1      res        1
temp2      res        1
time       res        1                
lus        res        1
lijn       res        1
terug      res        1
                                      
fit                                    'check for program fit in cog.